"use client"

import * as React from "react"
import Styles from "./dataTable.module.css"
import {
  ColumnDef,
  ColumnFiltersState,
  SortingState,
  VisibilityState,
  flexRender,
  getCoreRowModel,
  getFilteredRowModel,
  getPaginationRowModel,
  getSortedRowModel,
  useReactTable,
} from "@tanstack/react-table"
import { ArrowUpDown, ChevronDown, MoreHorizontal ,ChevronLeftIcon, ChevronRightIcon} from "lucide-react"

import { Button } from "@/components/ui/button"
import { Checkbox } from "@/components/ui/checkbox"
import {
  DropdownMenu,
  DropdownMenuCheckboxItem,
  DropdownMenuContent,
  DropdownMenuItem,
  DropdownMenuLabel,
  DropdownMenuSeparator,
  DropdownMenuTrigger,
} from "@/components/ui/dropdown-menu"
import { Input } from "@/components/ui/input"
import {
  Table,
  TableBody,
  TableCell,
  TableHead,
  TableHeader,
  TableRow,
} from "@/components/ui/table"
import { ScrollArea, ScrollBar } from "@/components/ui/scroll-area";
import { useSelector } from "react-redux"
import {
  Select,
  SelectContent,
  SelectItem,
  SelectTrigger,
  SelectValue,
} from "@/components/ui/select";
import {
  DoubleArrowLeftIcon,
  DoubleArrowRightIcon,
} from "@radix-ui/react-icons";
import { usePathname, useRouter, useSearchParams } from "next/navigation";
// Components
import { ComboBoxComponent } from "@/components/layout/combobox/combobox"
import {DatePickerComponent} from "@/components/layout/datePicker/datePicker"
import { useTranslation } from "react-i18next";
import { Label } from "@/components/ui/label"
import {
  Sheet,
  SheetClose,
  SheetContent,
  SheetDescription,
  SheetFooter,
  SheetHeader,
  SheetTitle,
  SheetTrigger,
} from "@/components/ui/sheet"


const data= [
  {
    code: "Emp-001",
    name: "John The first Doe",
    mobile:"0963997944852",
    email:"email@gmail.com",
    department: "Sales",
    position: "Sales Man",
    reportingTo:"Boss Doe",
    status:"active",
    evaluatedBy:"Evaluated By",
    accommodationType:"Accommodation Type",
    joinDate:"12-12-2023",
    departmentCode:"code-001",
    basicSalary:"1000$",
    daysOff:12,
    endOfServices:"end"
},
{
  code: "Emp-002",
  name: "John The first Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"active",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:12,
  endOfServices:"end"
},
{
  code: "Emp-003",
  name: "John The first Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"active",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:11,
  endOfServices:"end"
},
{
  code: "Emp-004",
  name: "John The three Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"inactive",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:12,
  endOfServices:"end"
},
{
  code: "Emp-005",
  name: "John The four Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"active",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:12,
  endOfServices:"end"
},
{
  code: "Emp-001",
  name: "John The first Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"active",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:12,
  endOfServices:"end"
},
{
code: "Emp-002",
name: "John The first Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
code: "Emp-003",
name: "John The first Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:11,
endOfServices:"end"
},
{
code: "Emp-004",
name: "John The three Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"inactive",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
code: "Emp-005",
name: "John The four Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
  code: "Emp-001",
  name: "John The first Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"active",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:12,
  endOfServices:"end"
},
{
code: "Emp-002",
name: "John The first Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
code: "Emp-003",
name: "John The first Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:11,
endOfServices:"end"
},
{
code: "Emp-004",
name: "John The three Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"inactive",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
code: "Emp-005",
name: "John The four Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
  code: "Emp-001",
  name: "John The first Doe",
  mobile:"0963997944852",
  email:"email@gmail.com",
  department: "Sales",
  position: "Sales Man",
  reportingTo:"Boss Doe",
  status:"active",
  evaluatedBy:"Evaluated By",
  accommodationType:"Accommodation Type",
  joinDate:"12-12-2023",
  departmentCode:"code-001",
  basicSalary:"1000$",
  daysOff:12,
  endOfServices:"end"
},
{
code: "Emp-002",
name: "John The first Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
code: "Emp-003",
name: "John The first Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:11,
endOfServices:"end"
},
{
code: "Emp-004",
name: "John The three Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"inactive",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
},
{
code: "Emp-005",
name: "John The four Doe",
mobile:"0963997944852",
email:"email@gmail.com",
department: "Sales",
position: "Sales Man",
reportingTo:"Boss Doe",
status:"active",
evaluatedBy:"Evaluated By",
accommodationType:"Accommodation Type",
joinDate:"12-12-2023",
departmentCode:"code-001",
basicSalary:"1000$",
daysOff:12,
endOfServices:"end"
}
]

// export const Payment = {
//   id: string
//   amount: number
//   status: "pending" | "processing" | "success" | "failed"
//   email: string
// }



export function DataTable() {
  const [sorting, setSorting] = React.useState([])
  const [visibility , setVisibility] = React.useState()
  const [columnVisibility, setColumnVisibility] =
    React.useState({})
  const [rowSelection, setRowSelection] = React.useState({})
  const [toggle, setToggle] = React.useState(false)
  const isToggle = useSelector(state=>(state.toggleSidebar.toggle))
  React.useEffect(()=>{
    // console.log(data);
    data.forEach(ele=>{
      // setVisibility(prev=>({...prev,[ele.code]:ele.view}))
    })
    if(localStorage.getItem("close")){
      const toggleFromLocalStorage = localStorage.getItem("close")
      setToggle(toggleFromLocalStorage=="true"?true:false)
    }else{
      setToggle(isToggle)
    }
    
  },[isToggle])
  
  const columns = [
    {
      id: "view",
      header: "",
      cell: ({ row }) => (
        <div  className={`${Styles.view} radius-less p-1 flex justify-center align-center`}>
                <i className="material-symbols-outlined  !w-fit font-size-l" >
                  visibility
                  </i>
              </div>
      ),
      // enableSorting: false,
      // enableHiding: false,
    },
    {
      accessorKey: "code",
      header: "Code",
      cell: ({ row }) => (
        <div className="capitalize w-max font-size-xxs font-semibold">{row.getValue("code")}</div>
      ),
    },
    {
      accessorKey: "name",
      header: ({ column }) => {
        return (
          <Button
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Name
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max font-size-xxs px-4 font-semibold">{row.getValue("name")}</div>
      ),
    },
    {
      accessorKey: "email",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Email
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max font-size-xxs px-4 font-semibold">{row.getValue("email")}</div>
      ),
    },
    {
      accessorKey: "mobile",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Mobile
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max font-size-xxs px-4 font-semibold">{row.getValue("mobile")}</div>
      ),
    },
    
    {
      accessorKey: "department",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-6  font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Department
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("department")}</div>
      ),
    },
    {
      accessorKey: "position",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Position
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("position")}</div>
      ),
    },
    {
      accessorKey: "reportingTo",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-16 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Reporting To
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold ">{row.getValue("reportingTo")}</div>
      ),
    },
    
    {
      accessorKey: "evaluatedBy",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-16 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Evaluated By
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max font-size-xxs px-4 font-semibold">{row.getValue("evaluatedBy")}</div>
      ),
    },
    {
      accessorKey: "accommodationType",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-24 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Accommodation Type
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max font-size-xxs px-4 font-semibold">{row.getValue("accommodationType")}</div>
      ),
    },
    {
      accessorKey: "joinDate",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-12 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Join Date
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("joinDate")}</div>
      ),
    },
    {
      accessorKey: "departmentCode",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-24 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
            Department Code
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("departmentCode")}</div>
      ),
    },
    {
      accessorKey: "basicSalary",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-16 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
           Basic Salary
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("basicSalary")}</div>
      ),
    },
    {
      accessorKey: "daysOff",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-4 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
           Days Off
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("daysOff")}</div>
      ),
    },
    {
      accessorKey: "endOfServices",
      header: ({ column }) => {
        return (
          <Button className="font-size-xxs min-w-12 font-semibold"
            variant="ghost"
            onClick={() => column.toggleSorting(column.getIsSorted() === "asc")}
          >
           End Of Services
            <ArrowUpDown className="ml-2 h-4 w-4" />
          </Button>
        )
      },
      cell: ({ row }) => (
        <div className="capitalize w-max px-4 font-size-xxs font-semibold">{row.getValue("endOfServices")}</div>
      ),
    },
    {
      accessorKey: "status",
      header: "Status",
      cell: ({ row }) => (
        <div className="capitalize font-bold">
          <div className={`${row.getValue("status")=="active"?Styles.active:Styles.inActive} p-2 radius-less font-size-xxs flex justify-center align-center`}>
            {row.getValue("status")}
          </div>
        
          
          </div>
      ),
    },
  ]
    const router = useRouter();
    const pathname = usePathname();
    const searchParams = useSearchParams();
     // Create query string
  const createQueryString = React.useCallback(
    (params) => {
      const newSearchParams = new URLSearchParams(searchParams?.toString());

      for (const [key, value] of Object.entries(params)) {
        if (value === null) {
          newSearchParams.delete(key);
        } else {
          newSearchParams.set(key, String(value));
        }
      }

      return newSearchParams.toString();
    },
    [searchParams],
  );
    // Search params
    const page = searchParams?.get("page") ?? "1";
    const pageSizeOptions = [10, 20, 50];
    const pageAsNumber = Number(page);
    const fallbackPage =
      isNaN(pageAsNumber) || pageAsNumber < 1 ? 1 : pageAsNumber;
    const per_page = searchParams?.get("limit") ?? "10";
    const perPageAsNumber = Number(per_page);
    const fallbackPerPage = isNaN(perPageAsNumber) ? 10 : perPageAsNumber;
   // Handle server-side pagination
   const [{ pageIndex, pageSize }, setPagination] =
   React.useState({
     pageIndex: fallbackPage - 1,
     pageSize: fallbackPerPage,
   });
  React.useEffect(() => {
    router.push(
      `${pathname}?${createQueryString({
        page: pageIndex + 1,
        limit: pageSize,
      })}`,
      {
        scroll: false,
      },
    );

    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [pageIndex, pageSize]);
  const table = useReactTable({
    data,
    columns,
    onSortingChange: setSorting,
    // onColumnFiltersChange: setColumnFilters,
    getCoreRowModel: getCoreRowModel(),
    getPaginationRowModel: getPaginationRowModel(),
    getSortedRowModel: getSortedRowModel(),
    getFilteredRowModel: getFilteredRowModel(),
    onColumnVisibilityChange: setColumnVisibility,
    onRowSelectionChange: setRowSelection,
    state: {
      sorting,
    //   columnFilters,
      columnVisibility,
      rowSelection,
      pagination: { pageIndex, pageSize },
    },
   
  })
  const dataStatus = [
    {
      value: "1",
      label: "Backlog",
    },
    {
      value: "2",
      label: "Todo",
    },
    {
      value: "3",
      label: "In Progress",
    },
    {
      value: "4",
      label: "Done",
    },
    {
      value: "5",
      label: "Canceled",
    },
  ]
  // for catch active language
  const { i18n } = useTranslation()
  const activeLang = i18n.language
  React.useEffect(()=>{
    table.getAllColumns().forEach(ele=>{
      if(ele.id=="mobile" || ele.id=="email" || ele.id=="evaluatedBy" || ele.id == "accommodationType" || ele.id=="joinDate"
        || ele.id == "end Of Services"|| ele.id == "departmentCode" || ele.id == "daysOff" || ele.id=="basicSalary"
      ){
        ele.toggleVisibility(false)
      }
    })
  },[])
  return (
    <div className="w-full">
      <div  className="flex items-center py-4">
        <div className="flex  w-full justify-between">
          <div className="lg:flex hidden gap-2">
            <Input
              placeholder="Search Name"
              value={(table.getColumn("name")?.getFilterValue()) ?? ""}
              onChange={(event) =>
                table.getColumn("name")?.setFilterValue(event.target.value)
              }
              className="max-w-64"
            />
            <ComboBoxComponent data={dataStatus} title={"Status"} returnedSelectedValue={(res)=>console.log(res,"basic")}/>
            <ComboBoxComponent data={dataStatus} title={"Reporting To"} returnedSelectedValue={(res)=>console.log(res,"basic")}/>
            <DatePickerComponent returnDate={(res)=>console.log(res)} title={"Join Date"} />
            <DatePickerComponent returnDate={(res)=>console.log(res)} title={"Search Until"} />
          </div>

          <div className="flex lg:hidden">
              <Sheet>
                <SheetTrigger asChild>
                  <Button variant="outline"><span className="material-symbols-outlined  !w-fit">
                      filter_list
                      </span></Button>
                </SheetTrigger>
                <SheetContent className="pt-14">
                  <SheetHeader>
                    <SheetTitle>Filter</SheetTitle>
                    <SheetDescription>
                      Filter in status and date to get result what you want .
                    </SheetDescription>
                  </SheetHeader>
                
                  <div className="grid gap-4 py-4 mt-5">
                    <div className=" w-full">
                            <Input
                          placeholder="Search Name"
                          value={(table.getColumn("name")?.getFilterValue()) ?? ""}
                          onChange={(event) =>
                            table.getColumn("name")?.setFilterValue(event.target.value)
                          }
                          className="w-full"
                        />
                    </div>
                    <div className=" w-full">
                          <ComboBoxComponent  data={dataStatus} title={"Status"} returnedSelectedValue={(res)=>console.log(res,"basic")}/>
                    </div>
                    <div className="w-full">
                        <ComboBoxComponent data={dataStatus} title={"Reporting To"} returnedSelectedValue={(res)=>console.log(res,"basic")}/>
                    </div>
                    <div className="w-full">
                        <DatePickerComponent returnDate={(res)=>console.log(res)} title={"Join Date"} />
                        
                    </div>
                    <div className="w-full">
                        <DatePickerComponent returnDate={(res)=>console.log(res)} title={"Search Until"} />
                    </div>
                  </div>
                  <SheetFooter>
                    <SheetClose asChild>
                      <Button className="w-full" type="submit">Apply</Button>
                    </SheetClose>
                  </SheetFooter>
                </SheetContent>
              </Sheet>
              
          </div>
          <div>
            <DropdownMenu>
              <DropdownMenuTrigger asChild>
                <Button variant="outline" className="ml-auto">
                  Columns <ChevronDown className="ml-2 h-4 w-4" />
                </Button>
              </DropdownMenuTrigger>
              <DropdownMenuContent className="p-0" align="end">
                <ScrollArea className={`rounded-md border h-72 w-full`}>
                  {table
                      .getAllColumns()
                      .filter((column) => column.getCanHide())
                      .map((column) => {
                        return (
                          <DropdownMenuCheckboxItem
                            key={column.id}
                            className="capitalize"
                            checked={column.getIsVisible()}
                            onCheckedChange={(value) =>
                              column.toggleVisibility(!!value)
                            }
                          >
                            {column.id}
                          </DropdownMenuCheckboxItem>
                        )
                      })}
                  <ScrollBar orientation="horizontal" />
                </ScrollArea>
                
              </DropdownMenuContent>
            </DropdownMenu>
          </div>

        </div>
        
        
      </div>
      <div className={`rounded-md border`} >
      
        <ScrollArea style={activeLang=="ar"?{direction:"rtl"}:{direction:"ltr"}} className={`rounded-md border w-full  ${toggle?"lg:w-[calc(100vw-184px)]":"lg:w-[calc(100vw-420px)]"} `}>
        <Table className="relative">
          <TableHeader>
          {table.getHeaderGroups().map((headerGroup) => (
              <TableRow key={headerGroup.id}>
                {headerGroup.headers.map((header) => {
                  return (
                    <TableHead  key={header.id}>
                      {header.isPlaceholder
                        ? null
                        : flexRender(
                            header.column.columnDef.header,
                            header.getContext()
                          )}
                    </TableHead>
                  )
                })}
              </TableRow>
            ))}
          </TableHeader>
          <TableBody>
          {table.getRowModel().rows?.length ? (
              table.getRowModel().rows.map((row) => (
                <TableRow
                  key={row.id}
                  data-state={row.getIsSelected() && "selected"}
                >
                  {row.getVisibleCells().map((cell) => (
                    <TableCell key={cell.id}>
                      {flexRender(
                        cell.column.columnDef.cell,
                        cell.getContext()
                      )}
                    </TableCell>
                  ))}
                </TableRow>
              ))
            ) : (
              <TableRow>
                <TableCell
                  colSpan={columns.length}
                  className="h-24 text-center"
                >
                  No results.
                </TableCell>
              </TableRow>
            )}
          </TableBody>
        </Table>
        <ScrollBar orientation="horizontal" />
      </ScrollArea>
      </div>
      <div className="flex flex-col gap-2  sm:flex-row items-center justify-end space-x-2 py-4">
        <div className="flex items-center justify-between w-full">
          <div className="flex-1 text-sm text-muted-foreground">
          Viewing {table.getFilteredSelectedRowModel().rows.length} out of  {table.getFilteredRowModel().rows.length}
            {/* {table.getFilteredSelectedRowModel().rows.length} of{" "}
            {table.getFilteredRowModel().rows.length} row(s) selected. */}
          </div>
          <div className="flex flex-col items-center gap-4 sm:flex-row sm:gap-6 lg:gap-8">
            <div className="flex items-center space-x-2">
              <p className="whitespace-nowrap text-sm font-medium">
                Rows per page
              </p>
              <Select
                value={`${table.getState().pagination.pageSize}`}
                onValueChange={(value) => {
                  table.setPageSize(Number(value));
                }}
              >
                <SelectTrigger className="h-8 w-[70px]">
                  <SelectValue
                    placeholder={table.getState().pagination.pageSize}
                  />
                </SelectTrigger>
                <SelectContent side="top">
                  {pageSizeOptions.map((pageSize) => (
                    <SelectItem key={pageSize} value={`${pageSize}`}>
                      {pageSize}
                    </SelectItem>
                  ))}
                </SelectContent>
              </Select>
            </div>
          </div>
        </div>
        <div className="flex items-center justify-between sm:justify-end gap-2 w-full">
          
          <div className="flex items-center space-x-2">
            <Button
              aria-label="Go to first page"
              variant="outline"
              className="hidden h-8 w-8 p-0 lg:flex shadow-box"
              onClick={() => table.setPageIndex(0)}
              disabled={!table.getCanPreviousPage()}
            >
              <DoubleArrowLeftIcon className="h-4 w-4" aria-hidden="true" />
            </Button>
            <Button
              aria-label="Go to previous page"
              variant="outline"
              className="h-8 w-8 p-0  shadow-box"
              onClick={() => table.previousPage()}
              disabled={!table.getCanPreviousPage()}
            >
              <ChevronLeftIcon className="h-4 w-4" aria-hidden="true" />
            </Button>
            <div className="flex w-[100px] items-center justify-center text-sm font-medium">
            Page {table.getState().pagination.pageIndex + 1} of{" "}
            {table.getPageCount()}
          </div>
            <Button
              aria-label="Go to next page"
              variant="outline"
              className="h-8 w-8 p-0  shadow-box"
              onClick={() => table.nextPage()}
              disabled={!table.getCanNextPage()}
            >
              <ChevronRightIcon className="h-4 w-4" aria-hidden="true" />
            </Button>
            <Button
              aria-label="Go to last page"
              variant="outline"
              className="hidden h-8 w-8 p-0 lg:flex  shadow-box"
              onClick={() => {
                table.setPageIndex(table.getPageCount() - 1)}}
              disabled={!table.getCanNextPage()}
            >
              <DoubleArrowRightIcon className="h-4 w-4" aria-hidden="true" />
            </Button>
          </div>
        </div>
      </div>
      {/* <div className="flex items-center justify-end space-x-2 py-4">
        <div className="flex-1 text-sm text-muted-foreground">
          {table.getFilteredSelectedRowModel().rows.length} of{" "}
          {table.getFilteredRowModel().rows.length} row(s) selected.
        </div>
        <div className="space-x-2">
          <Button
            variant="outline"
            size="sm"
            onClick={() => table.previousPage()}
            disabled={!table.getCanPreviousPage()}
          >
            Previous
          </Button>
          <Button
            variant="outline"
            size="sm"
            onClick={() => table.nextPage()}
            disabled={!table.getCanNextPage()}
          >
            Next
          </Button>
        </div>
      </div> */}
    </div>
  )
}